/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// DestinationsDataboxApiService DestinationsDataboxApi service
type DestinationsDataboxApiService service

type ApiAppDestinationDataboxDataboxDestinationActionAuthorizationRequest struct {
	ctx        context.Context
	ApiService *DestinationsDataboxApiService
}

func (r ApiAppDestinationDataboxDataboxDestinationActionAuthorizationRequest) Execute() ([]ActionAuthorizationResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationDataboxDataboxDestinationActionAuthorizationExecute(r)
}

/*
AppDestinationDataboxDataboxDestinationActionAuthorization List of authorization objects

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationDataboxDataboxDestinationActionAuthorizationRequest
*/
func (a *DestinationsDataboxApiService) AppDestinationDataboxDataboxDestinationActionAuthorization(ctx context.Context) ApiAppDestinationDataboxDataboxDestinationActionAuthorizationRequest {
	return ApiAppDestinationDataboxDataboxDestinationActionAuthorizationRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []ActionAuthorizationResponseInner
func (a *DestinationsDataboxApiService) AppDestinationDataboxDataboxDestinationActionAuthorizationExecute(r ApiAppDestinationDataboxDataboxDestinationActionAuthorizationRequest) ([]ActionAuthorizationResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodGet
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []ActionAuthorizationResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsDataboxApiService.AppDestinationDataboxDataboxDestinationActionAuthorization")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/databox/actions/authorization"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest struct {
	ctx                                                              context.Context
	ApiService                                                       *DestinationsDataboxApiService
	appDestinationOneDriveOneDriveDestinationActionWriteModesRequest *AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest
}

func (r ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest) AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest(appDestinationOneDriveOneDriveDestinationActionWriteModesRequest AppDestinationOneDriveOneDriveDestinationActionWriteModesRequest) ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest {
	r.appDestinationOneDriveOneDriveDestinationActionWriteModesRequest = &appDestinationOneDriveOneDriveDestinationActionWriteModesRequest
	return r
}

func (r ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest) Execute() ([]LabelValueResponseInner, *http.Response, error) {
	return r.ApiService.AppDestinationDataboxDataboxDestinationActionWriteModesExecute(r)
}

/*
AppDestinationDataboxDataboxDestinationActionWriteModes List of write modes

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest
*/
func (a *DestinationsDataboxApiService) AppDestinationDataboxDataboxDestinationActionWriteModes(ctx context.Context) ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest {
	return ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return []LabelValueResponseInner
func (a *DestinationsDataboxApiService) AppDestinationDataboxDataboxDestinationActionWriteModesExecute(r ApiAppDestinationDataboxDataboxDestinationActionWriteModesRequest) ([]LabelValueResponseInner, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue []LabelValueResponseInner
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsDataboxApiService.AppDestinationDataboxDataboxDestinationActionWriteModes")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/databox/actions/writeModes"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appDestinationOneDriveOneDriveDestinationActionWriteModesRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiAppDestinationDataboxDataboxDestinationCreateRequest struct {
	ctx                   context.Context
	ApiService            *DestinationsDataboxApiService
	databoxStorageRequest *DataboxStorageRequest
}

//
func (r ApiAppDestinationDataboxDataboxDestinationCreateRequest) DataboxStorageRequest(databoxStorageRequest DataboxStorageRequest) ApiAppDestinationDataboxDataboxDestinationCreateRequest {
	r.databoxStorageRequest = &databoxStorageRequest
	return r
}

func (r ApiAppDestinationDataboxDataboxDestinationCreateRequest) Execute() (*DataboxDestination, *http.Response, error) {
	return r.ApiService.AppDestinationDataboxDataboxDestinationCreateExecute(r)
}

/*
AppDestinationDataboxDataboxDestinationCreate Create destination

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppDestinationDataboxDataboxDestinationCreateRequest
*/
func (a *DestinationsDataboxApiService) AppDestinationDataboxDataboxDestinationCreate(ctx context.Context) ApiAppDestinationDataboxDataboxDestinationCreateRequest {
	return ApiAppDestinationDataboxDataboxDestinationCreateRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return DataboxDestination
func (a *DestinationsDataboxApiService) AppDestinationDataboxDataboxDestinationCreateExecute(r ApiAppDestinationDataboxDataboxDestinationCreateRequest) (*DataboxDestination, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *DataboxDestination
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "DestinationsDataboxApiService.AppDestinationDataboxDataboxDestinationCreate")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/destinations/databox"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.databoxStorageRequest == nil {
		return localVarReturnValue, nil, reportError("databoxStorageRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.databoxStorageRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
